/* Bullets */

var Bullets = [];
var BulletSS = LoadSpriteset("Bullet.rss")

function Bullet(turret)
{
	this.x = turret.x-7; this.y = turret.y-7;
	this.a = turret.a || Math.random()*Math.PI; this.s = 4;
	this.atk = turret.atk || 0;
	this.owner = turret;
	this.target = {};
	this.img = BulletSS.images[turret.img || 0];
	this.onEnd = function(){ Bullets.splice(Bullets.indexOf(this), 1); };
}

Bullet.prototype.update = function()
{
	if (IsMapEngineRunning())
		this.img.rotateBlit(MapToScreenX(0, this.x), MapToScreenY(0, this.y), this.a);
	else this.img.rotateBlit(this.x, this.y, this.a);
	this.x += Math.cos(this.a)*this.s;
	this.y += Math.sin(this.a)*this.s;

	if (this.x > SW || this.y > SH || this.x < 0 || this.y < 0) this.onEnd();
	else if (this.hasHitTarget())
	{
		var hp = this.target.hp;
		this.target.hp-=this.atk;
		
		if (this.target.hp <= 0)
		{
			Game.money += this.target.money;
			Enemies.splice(Enemies.indexOf(this.target), 1);
			this.owner.kills++;
			Game.mana++;
		}
		
		this.onEnd();
	}
}

Bullet.prototype.hasHitTarget = function()
{
	if (Enemies.indexOf(this.target) == -1) return false;
	
	var px = this.target.x;
	var py = this.target.y;
	
	return (this.x+8 > px && this.x+8 < px+16 && this.y+8 > py && this.y+8 < py+16);
}

function CreateBullet(turret)
{
	var bullet = new Bullet(turret);
	bullet.target = turret.target;
	bullet.onEnd = function(){ Bullets.splice(Bullets.indexOf(this), 1); };
	Bullets.push(bullet);
}

function UpdateBullets()
{
	var i = Bullets.length;
	while(i--) { Bullets[i].update(); }
}